VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLib"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" _
    (ByVal lpFileName As String) As Long

Private Declare Function GetProcAddress Lib "kernel32.dll" _
    (ByVal hModule As Long, ByVal lpProcName As String) As Long

Private Declare Function FreeLibrary Lib "kernel32.dll" _
    (ByVal hModule As Long) As Long

Private Declare Function DispCallFunc Lib "OleAut32.dll" _
    (ByVal pvInstance As Long, _
        ByVal oVft As Long, _
        ByVal cc As Long, _
        ByVal vtReturn As Integer, _
        ByVal cActuals As Long, _
        ByVal prgvt As Long, _
        ByVal prgpvarg As Long, _
        ByVal pvargResult As Long) As Long

Enum tagCALLCONV
    CC_FASTCALL = 0
    CC_CDECL = 1
    CC_MSCPASCAL = CC_CDECL + 1
    CC_PASCAL = CC_MSCPASCAL
    CC_MACPASCAL = CC_PASCAL + 1
    CC_STDCALL = CC_MACPASCAL + 1
    CC_FPFASTCALL = CC_STDCALL + 1
    CC_SYSCALL = CC_FPFASTCALL + 1
    CC_MPWCDECL = CC_SYSCALL + 1
    CC_MPWPASCAL = CC_MPWCDECL + 1
    CC_MAX = CC_MPWPASCAL
End Enum

Private Const ERR_SRC = "cLib"

'  
Private lLibraryHandle As Long

'  
Private tCallingConvention As tagCALLCONV

'  
Private lReturnValueType As Long

' 
Private Sub Class_Initialize()
    '   
    tCallingConvention = CC_STDCALL
    lReturnValueType = vbLong
End Sub

Sub Load(FileName As String)
    '    ,   
    If lLibraryHandle <> 0 Then Unload
    '   
    lLibraryHandle = LoadLibrary(FileName)
    '   
    If lLibraryHandle = 0 Then Err.Raise vbObjectError + 1, ERR_SRC, "Error loading module"
End Sub

'  
Public Property Let CallingConvention(value As tagCALLCONV)
    tCallingConvention = value
End Property

Public Property Get CallingConvention() As tagCALLCONV
    CallingConvention = tCallingConvention
End Property

'    DLL
Function CallFunc(ProcName As String, ParamArray Parameters() As Variant) As Variant
    Dim lProcAddress As Long
    Dim vReturnValue As Variant
    ReDim aTypes(UBound(Parameters)) As Integer
    ReDim aPointers(UBound(Parameters)) As Long
    Dim i
    '    
    lProcAddress = GetProcAddress(lLibraryHandle, ProcName)
    
    If lProcAddress = 0 Then Err.Raise vbObjectError + 1, ERR_SRC, "Function not found"
    
    '     
    For i = 0 To UBound(Parameters)
        aTypes(i) = VarType(Parameters(i))
        aPointers(i) = VarPtr(Parameters(i))
    Next
    
    '   
    Dim rv As Long
    rv = DispCallFunc(0, _
                      lProcAddress, _
                      tCallingConvention, _
                      lReturnValueType, _
                      UBound(Parameters) + 1, _
                      VarPtr(aTypes(0)), _
                      VarPtr(aPointers(0)), _
                      VarPtr(vReturnValue))
    If rv <> 0 Then Err.Raise vbObjectError + 2, ERR_SRC, "Function call failed"
    
    '   
    CallFunc = vReturnValue
End Function

' 
Sub Unload()
    FreeLibrary lhModule
End Sub

'      CallFunc
Public Property Let ReturnValueType(value As VbVarType)
    lReturnValueType = value
End Property

Public Property Get ReturnValueType() As VbVarType
    ReturnValueType = lReturnValueType
End Property

'   
Private Sub Class_Terminate()
    FreeLibrary lLibraryHandle
End Sub
